unit Login;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Exptfunc, StdCtrls, FileCtrl, Fsfunc;

type
  TLoginToServer = class(TForm)
    ServerUser: TEdit;
    ServerPassword: TEdit;
    ServerList: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    AvaliableDrives: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    LoginOK: TButton;
    LoginCancel: TButton;
    ExpertFunctions1: ExpertFunctions;
    ServerFunctions1: ServerFunctions;
    procedure LoginOKClick(Sender: TObject);
    procedure LoginCancelClick(Sender: TObject);
    procedure ReadInitialValues(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LoginToServer: TLoginToServer;

implementation

{$R *.DFM}

procedure TLoginToServer.LoginOKClick(Sender: TObject);

var
      Response : Word;

begin

     (* Server function preset to Attach *)

(*     If (ServerList.ItemIndex>-1) and (ServerUser.Text<>'') and (AvaliableDrives.Text<>'') then*)
     If (ServerList.ItemIndex>-1) and (ServerUser.Text<>'') then
     begin
        ServerFunctions1.FileServerName:=ServerList.Items[ServerList.ItemIndex];
        ServerFunctions1.UserName:=ServerUser.Text;
        ServerFunctions1.Password:=ServerPassword.Text;
        If AvaliableDrives.Text<>'' then
            ServerFunctions1.DriveLetter:=AvaliableDrives.Text[1]
        else
            ServerFunctions1.DriveLetter:=Chr(0);
        ServerFunctions1.Active:=True;
        ModalResult:=mrOK;
     end else
     begin
          If ServerList.ItemIndex=-1 then
             Response:=MessageDlg('Select a file server to login to',mtInformation,[mbOK],0);
          If ServerUser.Text='' then
             Response:=MessageDlg('Enter a user name to login with',mtInformation,[mbOK],0);
(*          If AvaliableDrives.Text='' then
             Response:=MessageDlg('Enter a drive to map the SYS volume to',mtInformation,[mbOK],0);*)
     end;
end;

procedure TLoginToServer.LoginCancelClick(Sender: TObject);
begin
     ModalResult:=mrCancel;
end;

procedure TLoginToServer.ReadInitialValues(Sender: TObject);

const
   LocalName : Array[0..2] of Char = 'D:'#0;

var
   BufferSize: Word;
   TempName  : Array[0..128] of Char;
   n         : Integer;
   Drive     : Char;
   SearchRec : TSearchRec;
   Mapping   : String;
   SearchMask: String[7];
   ServerName: String;

begin

     (* Get avaliable servers *)

     ExpertFunctions1.Active:=True;

     ServerList.Clear;

     For n:=0 to ExpertFunctions1.Information.Count-1 do
     begin
          ServerList.Items.Add(ExpertFunctions1.Information[n]);
     end;

     (* Set Avaliable Drives *)

     For n:=0 to 23 do
     begin
          Drive:=Chr(67+n);
          SearchMask:=Drive+':\*.*';
          If FindFirst(SearchMask,faVolumeID,SearchRec)=0 then
          begin
              LocalName[0]:=Drive;
              BufferSize:=SizeOf(TempName)-1;
              If WNetGetConnection(LocalName,TempName,@BufferSize)=WN_SUCCESS then
                 ServerName:=TempName
              else
                 ServerName:='';
              Mapping:=UpperCase(SearchRec.Name);
              AvaliableDrives.Items[n]:=Drive+': '+UpperCase(ServerName)+Mapping;
          end;
     end;

end;

end.
